import { TrieDb } from '../types';
export default class SyncDb implements TrieDb {
    private worker;
    constructor();
    checkpoint(): void;
    commit(): void;
    revert(): void;
    del(key: Uint8Array): void;
    get(key: Uint8Array): Uint8Array | null;
    put(key: Uint8Array, value: Uint8Array): void;
    trieRoot(): Uint8Array;
    terminate(): Promise<any>;
    private _waitOnStart;
    private _waitOnRead;
    private _executeWrite;
    private _executeRead;
    private _readSize;
    private _readBuffer;
}
